#!/bin/sh
#
# Starts dropbear sshd.
#

# Allow a few customizations from a config file
test -r /etc/default/dropbear && . /etc/default/dropbear

DROPBEAR_KEYTYPES="rsa dss ecc"
start() {
	DROPBEAR_ARGS="$DROPBEAR_ARGS -R"

	local ktype file
	for ktype in rsa dss ecdsa; do
		file="/etc/dropbear/dropbear_${ktype}_host_key"
		cirros-per instance dropbear-keygen-$ktype \
			dropbearkey -t "$ktype" -f "$file" >/dev/null 2>&1 ||
		echo "WARN: generating key of type $ktype failed!"
	done
	echo -n "Starting dropbear sshd: "
	umask 077
	start-stop-daemon -S -q -p /var/run/dropbear.pid \
		--exec /usr/sbin/dropbear -- $DROPBEAR_ARGS
	[ $? = 0 ] && echo "OK" || echo "FAIL"
}
stop() {
	echo -n "Stopping dropbear sshd: "
	start-stop-daemon -K -q -p /var/run/dropbear.pid
	[ $? = 0 ] && echo "OK" || echo "FAIL"
}
restart() {
	stop
	start
}

case "$1" in
  start)
  	start
	;;
  stop)
  	stop
	;;
  restart|reload)
  	restart
	;;
  *)
	echo "Usage: $0 {start|stop|restart}"
	exit 1
esac

exit $?
